<%- include('./partials/header', {req, res, title: 'Homepage'}) %>
<!-- Styles -->
<style>
    #esp0Chart1 {
        width: 100%;
        height: 500px;
    }
</style>
<%- include('./partials/file-start', {req, res}) %>
<%- include('./partials/menu', {req, res}) %>
<h1>Homepage</h1>
<div id="graphs"></div>
<div>
    <h2>Tables</h2>
</div>
<table id="measurementsTable" class="display" width="100%"></table>
<%- include('./partials/footer', {req, res}) %>
<!--<link rel="stylesheet" href="//cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js">-->
<script src="//cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js"></script>
<script src="//momentjs.com/downloads/moment-with-locales.js"></script>
<script src="//www.chartjs.org/dist/2.8.0/Chart.min.js"></script>
<script src="//www.chartjs.org/samples/latest/utils.js"></script>
<!-- Chart resources -->
<script src="//www.amcharts.com/lib/4/core.js"></script>
<script src="//www.amcharts.com/lib/4/charts.js"></script>
<script src="//www.amcharts.com/lib/4/themes/dark.js"></script>
<script src="//www.amcharts.com/lib/4/themes/animated.js"></script>

<script>
    function generateGraphForDevice(device, i = 0) {
        $('#graphs').append(`<h2>${device}</h2><div id='graph${i}${device}' style='min-height: 500px;'></div>`);
        am4core.ready(function () {

            // Themes begin
            am4core.useTheme(am4themes_animated);
            // Themes end

            // Create chart instance
            var chart = am4core.create(`graph${i}${device}`, am4charts.XYChart);

            // Increase contrast by taking evey second color
            chart.colors.step = 2;

            // Add data
            //chart.data = generateChartData();

            // Add data
            function setChartData(chart, device) {
                let url = `/api/get/${device}`;
                var chartData = [];
                $.get(url, {
                    //name: device,
                }, function (getResult) {
                    for (let i = 0; i < getResult.length; i++) {
                        chartData.push({
                            date: new Date(getResult[i].date),
                            temperature: getResult[i].temperature,
                            humidity: getResult[i].humidity,
                            altitude: getResult[i].altitude,
                            soundVolume: getResult[i].soundVolume,
                            light: getResult[i].light,
                        });
                    }
                    chart.data = chartData;
                });
            };
            setChartData(chart, 'esp0');

            // Create axes
            var dateAxis = chart.xAxes.push(new am4charts.DateAxis());
            dateAxis.renderer.minGridDistance = 50;

            // Create series
            function createAxisAndSeries(field, name, opposite, bullet) {
                var valueAxis = chart.yAxes.push(new am4charts.ValueAxis());

                var series = chart.series.push(new am4charts.LineSeries());
                series.dataFields.valueY = field;
                series.dataFields.dateX = "date";
                series.strokeWidth = 2;
                series.yAxis = valueAxis;
                series.name = name;
                series.tooltipText = "{name}: [bold]{valueY}[/]";
                series.tensionX = 0.8;

                var interfaceColors = new am4core.InterfaceColorSet();
                /*
                            switch (bullet) {
                                case "triangle":
                                    var bullet = series.bullets.push(new am4charts.Bullet());
                                    bullet.width = 12;
                                    bullet.height = 12;
                                    bullet.horizontalCenter = "middle";
                                    bullet.verticalCenter = "middle";
                
                                    var triangle = bullet.createChild(am4core.Triangle);
                                    triangle.stroke = interfaceColors.getFor("background");
                                    triangle.strokeWidth = 2;
                                    triangle.direction = "top";
                                    triangle.width = 12;
                                    triangle.height = 12;
                                    break;
                                case "rectangle":
                                    var bullet = series.bullets.push(new am4charts.Bullet());
                                    bullet.width = 10;
                                    bullet.height = 10;
                                    bullet.horizontalCenter = "middle";
                                    bullet.verticalCenter = "middle";
                
                                    var rectangle = bullet.createChild(am4core.Rectangle);
                                    rectangle.stroke = interfaceColors.getFor("background");
                                    rectangle.strokeWidth = 2;
                                    rectangle.width = 10;
                                    rectangle.height = 10;
                                    break;
                                default:
                                    var bullet = series.bullets.push(new am4charts.CircleBullet());
                                    bullet.circle.stroke = interfaceColors.getFor("background");
                                    bullet.circle.strokeWidth = 2;
                                    break;
                            }
                */
                valueAxis.renderer.line.strokeOpacity = 1;
                valueAxis.renderer.line.strokeWidth = 1;
                valueAxis.renderer.line.stroke = series.stroke;
                valueAxis.renderer.labels.template.fill = series.stroke;
                valueAxis.renderer.opposite = opposite;
                valueAxis.renderer.grid.template.disabled = false // true;
            }

            createAxisAndSeries("temperature", "Temperatures", false, "circle");
            createAxisAndSeries("humidity", "Humidity", true, "triangle");
            createAxisAndSeries("altitude", "Altitudes", true, "rectangle");
            createAxisAndSeries("soundVolume", "Volume of sound", true, "rectangle");
            createAxisAndSeries("light", "Light", true, "rectangle");

            // Add legend
            chart.legend = new am4charts.Legend();

            // Add cursor
            chart.cursor = new am4charts.XYCursor();
        }); // end am4core.ready()
    }

    function generateTemperatureGraphForDevice(device, i = 0) {
        $('#graphs').append(`<h2>${device} - Temperature</h2><div id='graphTemp${i}${device}' style='min-height: 500px;'></div>`);
        /* Chart code */
        am4core.ready(function () {

            // Themes begin
            //am4core.useTheme(am4themes_dark);
            am4core.useTheme(am4themes_animated);
            // Themes end

            // Create chart instance
            var chart = am4core.create(`graphTemp${i}${device}`, am4charts.XYChart);

            // Add data
            //chart.data = getChartData(chart, device, i);
            function setChartData(chart, device, i) {
                let url = `/api/get/${device}`;
                var chartData = [];
                $.get(url, {
                    //name: device,
                }, function (getResult) {
                    for (let i = 0; i < getResult.length; i++) {
                        chartData.push({
                            date: new Date(getResult[i].date),
                            temperature: getResult[i].temperature,
                        });
                    }
                    chart.data = chartData;
                });
            };
            setChartData(chart, device, i);

            // Create axes
            var dateAxis = chart.xAxes.push(new am4charts.DateAxis());
            dateAxis.startLocation = 0.5;
            dateAxis.endLocation = 0.5;

            // Create value axis
            var valueAxis = chart.yAxes.push(new am4charts.ValueAxis());

            // Create series
            var series = chart.series.push(new am4charts.LineSeries());
            series.dataFields.valueY = "temperature";
            series.dataFields.dateX = "date";
            series.strokeWidth = 3;
            series.tooltipText = "{valueY.value}";
            series.fillOpacity = 0.1;

            // Create a range to change stroke for values below 0
            var range = valueAxis.createSeriesRange(series);
            range.value = 0;
            range.endValue = -1000;
            range.contents.stroke = chart.colors.getIndex(4);
            range.contents.fill = range.contents.stroke;
            range.contents.strokeOpacity = 0.7;
            range.contents.fillOpacity = 0.1;

            // Add cursor
            chart.cursor = new am4charts.XYCursor();
            chart.cursor.xAxis = dateAxis;
            chart.scrollbarX = new am4core.Scrollbar();

        }); // end am4core.ready()
    }

    $(document).ready(() => {
        $.getJSON('/api/getall', (data) => {
            //console.log(data);
            for (let i = 0; i < data.length; i++) {
                data[i].date = moment(data[i].date).format('YYYY-MM-DD HH:mm:ss');
            }
            //console.log(data);
            //var aDemoItems = data.lDemographicItems; //
            //var jsonString = JSON.stringify(aDemoItems) //for testing

            //Load  datatable
            let measurementsTable = $("#measurementsTable");

            measurementsTable.DataTable({
                "data": data, //jsonString,
                //order: [[4, 'asc']],
                "columns": [
                    { data: "_id", title: "ID", visible: false },
                    { data: "date", title: 'Date', /*order: "asc" */ },
                    { data: "author", title: "Author" },
                    { data: "location", title: "Location" },
                    { data: "altitude", title: "Altitude" },
                    { data: "temperature", title: "Temperature" },
                    { data: "humidity", title: "Humidity" },
                    { data: "soundVolume", title: "Volume of sound" },
                    { data: "light", title: "Light" },
                ]
            });
        });

        generateGraphForDevice('esp0');
        generateTemperatureGraphForDevice('esp0');
    });
</script>

<%- include('./partials/file-end', {req, res}) %>